Index: /trunk/src/VBox/Frontends/VirtualBox/src/VBoxImportAppliance.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/VBoxImportAppliance.cpp	(revision 16702)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/VBoxImportAppliance.cpp	(revision 16703)
@@ -956,45 +956,43 @@
     {
         CVirtualBox vbox = vboxGlobal().virtualBox();
-        /* Open the appliance */
+        /* Create a appliance object */
         CAppliance appliance = vbox.CreateAppliance();
-        if (appliance.isOk())
+        bool fResult = appliance.isOk();
+        if (fResult)
         {
-            appliance.Read(file); // @todo error handling
-            /* Now we have to interpret that stuff */
-            appliance.Interpret();
-            if (appliance.isOk())
-            {
-                /* Let the user do some tuning */
-                VBoxImportApplianceDlg settingsDlg (&appliance, aParent);
-                if (settingsDlg.exec() == QDialog::Accepted)
-                {
-                    /* Start the import asynchronously */
-                    CProgress progress;
-                    progress = appliance.ImportMachines();
-                    if (!appliance.isOk())
+            /* Read the appliance */
+            appliance.Read (file);
+            fResult = appliance.isOk();
+            if (fResult)
+            {
+                /* Now we have to interpret that stuff */
+                appliance.Interpret();
+                fResult = appliance.isOk();
+                if (fResult)
+                {
+                    /* Let the user do some tuning */
+                    VBoxImportApplianceDlg settingsDlg (&appliance, aParent);
+                    if (settingsDlg.exec() == QDialog::Accepted)
                     {
-                        vboxProblem().cannotImportAppliance (appliance);
-                        return;
+                        /* Start the import asynchronously */
+                        CProgress progress;
+                        progress = appliance.ImportMachines();
+                        fResult = appliance.isOk();
+                        if (fResult)
+                        {
+                            /* Show some progress, so the user know whats going on */
+                            vboxProblem().showModalProgressDialog (progress, VBoxImportApplianceDlg::tr ("Importing Appliance ..."), aParent);
+                            if (!progress.isOk() || progress.GetResultCode() != 0)
+                            {
+                                vboxProblem().cannotImportAppliance (progress, appliance);
+                                return;
+                            }
+                        }
                     }
-                    /* Show some progress, so the user know whats going on */
-                    vboxProblem().showModalProgressDialog (progress, VBoxImportApplianceDlg::tr ("Importing Appliance ..."), aParent);
-                    if (!progress.isOk() || progress.GetResultCode() != 0)
-                    {
-                        vboxProblem().cannotImportAppliance (progress, appliance);
-                        return;
-                    }
-                }
-            }
-            else
-            {
-                vboxProblem().cannotImportAppliance (appliance);
-                return;
+                }
             }
         }
-        else
-        {
+        if (!fResult)
             vboxProblem().cannotImportAppliance (appliance);
-            return;
-        }
     }
 }
Index: /trunk/src/VBox/Frontends/VirtualBox/ui/VBoxImportApplianceDlg.ui
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/ui/VBoxImportApplianceDlg.ui	(revision 16702)
+++ /trunk/src/VBox/Frontends/VirtualBox/ui/VBoxImportApplianceDlg.ui	(revision 16703)
@@ -6,6 +6,6 @@
     <x>0</x>
     <y>0</y>
-    <width>627</width>
-    <height>401</height>
+    <width>573</width>
+    <height>476</height>
    </rect>
   </property>
@@ -21,4 +21,17 @@
   <layout class="QGridLayout" name="gridLayout" >
    <item row="0" column="0" >
+    <widget class="QLabel" name="mInfoText" >
+     <property name="text" >
+      <string>These are the Virtual Machines as described in the Appliance. VirtualBox has done some initial mapping of the various values. You can change most of the shown properties by double clicking on the items. To disable some of them use the check box near the values.</string>
+     </property>
+     <property name="alignment" >
+      <set>Qt::AlignLeading|Qt::AlignLeft|Qt::AlignTop</set>
+     </property>
+     <property name="wordWrap" >
+      <bool>true</bool>
+     </property>
+    </widget>
+   </item>
+   <item row="1" column="0" >
     <widget class="QTreeView" name="mTvSettings" >
      <property name="sizePolicy" >
@@ -30,5 +43,5 @@
     </widget>
    </item>
-   <item row="1" column="0" >
+   <item row="2" column="0" >
     <widget class="QWidget" native="1" name="mWarningWidget" >
      <property name="sizePolicy" >
@@ -71,5 +84,5 @@
     </widget>
    </item>
-   <item row="2" column="0" >
+   <item row="3" column="0" >
     <widget class="QIDialogButtonBox" name="mButtonBox" >
      <property name="orientation" >
@@ -88,4 +101,5 @@
    <extends>QDialog</extends>
    <header>QIDialog.h</header>
+   <container>1</container>
   </customwidget>
   <customwidget>